using System;
using System.IO;
using System.Collections;

namespace Stubgen
{
	public class Options
	{
		public String outfile=null;
		private Hashtable flags;
		private TextWriter outstream=null;

		internal ArrayList files;
		
		public Options()
		{
			flags=new Hashtable();
			files=new ArrayList();
		}

		public void AddFile(String file)
		{
			files.Add(file);
		}
	
		public void Add(String flag)
		{
			if(flag.IndexOf("=")==-1)
			{
				this[flag]="true";
			}	
			else
			{
				String key=flag.Substring(0,flag.IndexOf("="));
				String val=flag.Substring(flag.IndexOf("=")+1);
				this[key]=val;
			}
		}

		public TextWriter Out
		{
			get
			{
				if(outstream==null)
				{
					if(outfile!=null)
					{
						outstream=new StreamWriter(outfile);
					}
					else
					{
						outstream=Console.Out;
					}
				}
				return outstream;
			}
		}

		public String this[String flag]
		{
			get
			{
				return (flags[flag] as String);
			}
			set
			{
				flags[flag]=value;
			}
		}
	}
}
